链接:https://leetcode-cn.com/problems/contains-duplicate-ii/
给定一个整数数组和一个整数 k,判断数组中是否存在两个不同的索引 i 和 j,使得 nums [i] = nums [j],并且 i 和 j 的差的 绝对值 至多为 k。
示例 1:
输入: nums = [1,2,3,1], k = 3 输出: true
示例 2:
输入: nums = [1,0,1,1], k = 1 输出: true
示例 3:
输入: nums = [1,2,3,1,2,3], k = 2 输出: false
思路1:哈希表,我们知道,为了使得两个相同元素间的距离最短,因此我们找的两个相同元素之间没有第三个元素和他们的值相同。我们转换一下,对于每一个数nums[j],在[0,j-1]区间找一个nums[i]满足这种要求,也就是nums[j]上次出现的位置就是nums[i],我们用哈希表进行维护即可。
class Solution {
public:
bool containsNearbyDuplicate(vector<int>& nums, int k) {
unordered_map<int,int> hash;
int i, n = nums.size();
for(i = 0; i < n; ++ i){
if(hash.find(nums[i]) != hash.end() && i - hash[nums[i]] <= k){
return true;
}
hash[nums[i]] = i;
}
return false;
}
};
思路2:滑动窗口优化。由于题目要求abs(j-i)<=k,因此我们不妨就维护一个大小为k + 1的窗口,判断里面是否有重复元素即可。这样哈希表里的元素个数至多为k + 1个,能大幅提高哈希表的查询性能。
class Solution {
public:
bool containsNearbyDuplicate(vector<int>& nums, int k) {
unordered_map<int,int> hash;
int n = nums.size(), L = -1, R = -1;
while(R < n - 1 && R < k){
if(hash[nums[++ R]] != 0) return true;
hash[nums[R]] += 1;
}
while(R < n - 1){
hash[nums[++ L]] -= 1;
if(hash[nums[++ R]] != 0) return true;
hash[nums[R]] += 1;
}
return false;
}
};
class Solution {
public:
bool containsNearbyDuplicate(vector<int>& nums, int k) {
unordered_map<int,int> hash;
int n = nums.size(), i;
for(i = 0; i < n; ++ i){
if(i > k){
hash[nums[i - k - 1]] -= 1;
}
if(hash[nums[i]] != 0){
return true;
}
hash[nums[i]] += 1;
}
return false;
}
};